diff --git a/src/main/java/net/minecraft/client/gui/SwitchElement.java b/src/main/java/net/minecraft/client/gui/SwitchElement.java
index 582577ffc..138684442 100644
--- a/src/main/java/net/minecraft/client/gui/SwitchElement.java
+++ b/src/main/java/net/minecraft/client/gui/SwitchElement.java
@@ -3,6 +3,7 @@ package net.minecraft.client.gui;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.Font;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import org.lwjgl.opengl.GL11;
 
 public class SwitchElement
@@ -10,6 +11,8 @@ public class SwitchElement
     private final String onText;
     private final String offText;
 
+    public IconCoordinate backgroundTexture;
+
     private boolean on;
 
     public SwitchElement(int id, int xPosition, int yPosition, boolean on, String onText, String offText) {
@@ -29,6 +32,13 @@ public class SwitchElement
         this.offText = offText;
         updateText();
     }
+    @Override
+    protected void setDefaultTextures() {
+        backgroundTexture = TextureRegistry.getTexture("minecraft:gui/widgets/switch/switch_background");
+        defaultTexture = TextureRegistry.getTexture("minecraft:gui/widgets/switch/switch");
+        hoveredTexture = TextureRegistry.getTexture("minecraft:gui/widgets/switch/switch_highlighted");
+        disabledTexture = TextureRegistry.getTexture("minecraft:gui/widgets/switch/switch_disabled");
+    }
 
     private void updateText() {
         if (this.on) {
@@ -72,7 +82,7 @@ public class SwitchElement
         }
 
         // Draw background
-        drawGuiIcon(xPosition, yPosition, width, height, disabledTexture);
+        drawGuiIcon(xPosition, yPosition, width, height, backgroundTexture);
 
         // Draw foreground
         drawGuiIcon(xPosition + xBar, yPosition, (width * 2)/3, height, tex);
diff --git a/src/main/java/net/minecraft/client/gui/TextFieldElement.java b/src/main/java/net/minecraft/client/gui/TextFieldElement.java
index fe042f86e..e70d408e5 100644
--- a/src/main/java/net/minecraft/client/gui/TextFieldElement.java
+++ b/src/main/java/net/minecraft/client/gui/TextFieldElement.java
@@ -84,11 +84,11 @@ public class TextFieldElement extends Gui implements ITextField
         }
     }
 
-    public void mouseClicked(int i, int j, int k)
+    public void mouseClicked(int x, int y, int mouseButton)
     {
-        boolean flag = isEnabled && i >= xPosition && i < xPosition + width && j >= yPosition && j < yPosition + height;
+        boolean flag = isEnabled && x >= xPosition && x < xPosition + width && y >= yPosition && y < yPosition + height;
         setFocused(flag);
-        if(flag && k == 1) {
+        if(flag && mouseButton == 1) {
         	setText("");
         }
     }
diff --git a/src/main/java/net/minecraft/client/gui/achievements/AchievementsScreen.java b/src/main/java/net/minecraft/client/gui/achievements/AchievementsScreen.java
index e0f690869..a68d746f5 100644
--- a/src/main/java/net/minecraft/client/gui/achievements/AchievementsScreen.java
+++ b/src/main/java/net/minecraft/client/gui/achievements/AchievementsScreen.java
@@ -898,7 +898,7 @@ public class AchievementsScreen extends Screen
             renderItem.render(page.getIcon(), x, y2 + (PAGE_BUTTON_HEIGHT / 2) - 9);
             if (page.getCompletionFraction(statsCounter) >= 1) {
                 GL11.glColor4f(1f, 1f, 1f, 1f);
-                drawGuiIcon(x + 8, y2 + (PAGE_BUTTON_HEIGHT / 2) - 9 + 8, 11, 11, TextureRegistry.getTexture("minecraft:gui/achievement/star"));
+                drawGuiIcon(x + 8, y2 + (PAGE_BUTTON_HEIGHT / 2) - 9 + 8, 11, 11, TextureRegistry.getTexture("minecraft:gui/screen/achievement/star"));
             }
             mc.font.drawStringWithShadow(name, x + 19, y2 + (PAGE_BUTTON_HEIGHT / 2) - 4, textColor);
             y2 += PAGE_BUTTON_HEIGHT;
diff --git a/src/main/java/net/minecraft/client/gui/chat/SleepScreenMP.java b/src/main/java/net/minecraft/client/gui/chat/SleepScreenMP.java
index e67cd2f9f..a6afc0f4c 100644
--- a/src/main/java/net/minecraft/client/gui/chat/SleepScreenMP.java
+++ b/src/main/java/net/minecraft/client/gui/chat/SleepScreenMP.java
@@ -3,16 +3,12 @@ package net.minecraft.client.gui.chat;
 import net.minecraft.client.entity.player.MultiplayerLocalPlayer;
 import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.net.handler.ClientPacketHandler;
-import net.minecraft.core.net.packet.PlayerCommandPacket;
+import net.minecraft.core.net.packet.UpdatePlayerStatePacket;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.net.ChatEmotes;
 import net.minecraft.core.lang.I18n;
 import org.lwjgl.input.Keyboard;
 
-// Referenced classes of package net.minecraft.src:
-//            GuiChat, StringTranslate, GuiButton, LocalPlayer,
-//            MultiplayerLocalPlayer, PlayerCommandPacket, ClientPacketHandler
-
 public class SleepScreenMP extends ChatScreen
 {
 
@@ -24,8 +20,8 @@ public class SleepScreenMP extends ChatScreen
 	public void init()
     {
         Keyboard.enableRepeatEvents(true);
-        I18n stringtranslate = I18n.getInstance();
-        buttons.add(new ButtonElement(1, width / 2 - 100, height - 40, stringtranslate.translateKey("gui.sleeping.multiplayer.leave_bed")));
+        I18n i18n = I18n.getInstance();
+        buttons.add(new ButtonElement(1, width / 2 - 100, height - 40, i18n.translateKey("gui.sleeping.multiplayer.leave_bed")));
 		int emotePickerYCells = (int)MathHelper.clamp(Math.ceil(ChatEmotes.getEmotes().size() / 5.0), 0, 4);
 		emotePicker = new ChatEmotePickerElement(mc, this, 5, emotePickerYCells);
 		showEmotePicker = false;
@@ -42,7 +38,7 @@ public class SleepScreenMP extends ChatScreen
 	public void keyPressed(char eventCharacter, int eventKey, int mx, int my) {
     	super.keyPressed(eventCharacter, eventKey, mx, my);
     	if(eventKey == Keyboard.KEY_ESCAPE) {
-    		func_22115_j();
+    		leaveBed();
     	}
     }
 
@@ -57,19 +53,19 @@ public class SleepScreenMP extends ChatScreen
     {
         if(button.id == 1)
         {
-            func_22115_j();
+            leaveBed();
         } else
         {
             super.buttonClicked(button);
         }
     }
 
-    private void func_22115_j()
+    private void leaveBed()
     {
         if(mc.thePlayer instanceof MultiplayerLocalPlayer)
         {
-            ClientPacketHandler netclienthandler = ((MultiplayerLocalPlayer)mc.thePlayer).sendQueue;
-            netclienthandler.addToSendQueue(new PlayerCommandPacket(mc.thePlayer, 3));
+            ClientPacketHandler sendQueue = ((MultiplayerLocalPlayer)mc.thePlayer).sendQueue;
+            sendQueue.addToSendQueue(new UpdatePlayerStatePacket(UpdatePlayerStatePacket.STATE_LEAVE_BED));
         }
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/container/ContainerScreen.java b/src/main/java/net/minecraft/client/gui/container/ContainerScreen.java
index 3b94caaa3..86d38a502 100644
--- a/src/main/java/net/minecraft/client/gui/container/ContainerScreen.java
+++ b/src/main/java/net/minecraft/client/gui/container/ContainerScreen.java
@@ -11,16 +11,15 @@ import org.lwjgl.opengl.GL11;
 public class ContainerScreen extends AbstractContainerScreen
 {
 
-    public ContainerScreen(Container iinventory, Container iinventory1)
+    public ContainerScreen(Container containerUpper, Container containerLower)
     {
-        super(new ContainerMenu(iinventory, iinventory1));
+        super(new ContainerMenu(containerUpper, containerLower));
         inventoryRows = 0;
-        upperChestInventory = iinventory;
-        lowerChestInventory = iinventory1;
+        upperChestInventory = containerUpper;
+        lowerChestInventory = containerLower;
         passEvents = false;
-        char c = '\336';
-        int i = c - 108;
-        inventoryRows = iinventory1.getContainerSize() / 9;
+        int i = 97 /*Bottom section height of gui*/ + 17 /*Top Section height of gui*/ - 1 /*fixes very slight off by 1 issue*/;
+        inventoryRows = containerLower.getContainerSize() / 9;
         ySize = i + inventoryRows * 18;
     }
 
@@ -34,6 +33,7 @@ public class ContainerScreen extends AbstractContainerScreen
     @Override
 	protected void drawGuiContainerBackgroundLayer(float f)
     {
+        GL11.glEnable(GL11.GL_BLEND);
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/container.png").bind();
         int x = (width - xSize) / 2;
diff --git a/src/main/java/net/minecraft/client/gui/container/InventoryScreenCreative.java b/src/main/java/net/minecraft/client/gui/container/InventoryScreenCreative.java
index f7722ea52..d8b0d023c 100644
--- a/src/main/java/net/minecraft/client/gui/container/InventoryScreenCreative.java
+++ b/src/main/java/net/minecraft/client/gui/container/InventoryScreenCreative.java
@@ -22,7 +22,7 @@ public class InventoryScreenCreative extends InventoryScreen implements ITextCha
 {
 	protected ButtonElement lastPageButton;
 	protected ButtonElement nextPageButton;
-	protected OptionsButtonElement clearSearchButton;
+	protected ButtonElement clearSearchButton;
 	protected TextFieldElement searchField;
 	protected CreativeInventoryMenu container;
 	protected String pageString = "1/1";
@@ -43,7 +43,7 @@ public class InventoryScreenCreative extends InventoryScreen implements ITextCha
 		super.init();
 		buttons.add(lastPageButton = new ButtonElement(500, 0, 0, 20, 20, "<"));
 		buttons.add(nextPageButton = new ButtonElement(501, 0, 0, 20, 20, ">"));
-		buttons.add(clearSearchButton = new OptionsButtonElement(0, 0, 10, 12, 20, "X"));
+		buttons.add(clearSearchButton = new OptionsButtonElement(0, 0, 10, 12, 20, "").setTextures("minecraft:gui/screen/creative/clear", "minecraft:gui/screen/creative/clear_highlighted", null));
 		searchField = new TextFieldElement(this, font, 0, 0, 96, 18, container.searchText, I18n.getInstance().translateKey("gui.inventory.creative.label.search"));
 		searchField.drawBackground =false;
 		searchField.setMaxStringLength(14);
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/GuidebookPage.java b/src/main/java/net/minecraft/client/gui/guidebook/GuidebookPage.java
index a843288b1..c46fc54f6 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/GuidebookPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/GuidebookPage.java
@@ -3,6 +3,8 @@ package net.minecraft.client.gui.guidebook;
 import net.minecraft.client.gui.Gui;
 import net.minecraft.client.render.Font;
 import net.minecraft.client.render.TextureManager;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.util.helper.Color;
 import org.lwjgl.opengl.GL11;
 
 public abstract class GuidebookPage
@@ -49,4 +51,15 @@ public abstract class GuidebookPage
     public void onBecomeVisible() { }
 
     public void onStopBeingVisible() { }
+
+
+    public void drawSlot(int x, int y, int argb){
+
+        float a = Color.alphaFromInt(argb) / 255F;
+        float r = Color.redFromInt(argb) / 255F;
+        float g = Color.greenFromInt(argb) / 255F;
+        float b = Color.blueFromInt(argb) / 255F;
+        GL11.glColor4f(r,g,b,a);
+        drawGuiIcon(x, y, 18, 18, TextureRegistry.getTexture("minecraft:gui/screen/guidebook/slot"));
+    }
 }
diff --git a/src/main/java/net/minecraft/client/gui/hud/DoomIngameHud.java b/src/main/java/net/minecraft/client/gui/hud/DoomIngameHud.java
index af5b68453..b294dcc49 100644
--- a/src/main/java/net/minecraft/client/gui/hud/DoomIngameHud.java
+++ b/src/main/java/net/minecraft/client/gui/hud/DoomIngameHud.java
@@ -4,6 +4,7 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.PhotoModeScreen;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.util.helper.MathHelper;
@@ -46,7 +47,7 @@ public class DoomIngameHud
         }
 
         // Render pumpkin overlay
-        ItemStack headSlotItem = mc.thePlayer.inventory.armorItemInSlot(3);
+        ItemStack headSlotItem = mc.thePlayer.inventory.armorItemInSlot(IArmorItem.PIECE_HEAD);
         if (mc.gameSettings.thirdPersonView.value == 0 && headSlotItem != null && headSlotItem.itemID == Blocks.PUMPKIN_CARVED_IDLE.id)
         {
             renderPumpkinBlur(width, height);
diff --git a/src/main/java/net/minecraft/client/gui/hud/IngameHud.java b/src/main/java/net/minecraft/client/gui/hud/IngameHud.java
index c4e3f7aaa..213eac8ca 100644
--- a/src/main/java/net/minecraft/client/gui/hud/IngameHud.java
+++ b/src/main/java/net/minecraft/client/gui/hud/IngameHud.java
@@ -16,6 +16,7 @@ import net.minecraft.client.gui.Gui;
 import net.minecraft.client.gui.HeldItemTooltipElement;
 import net.minecraft.client.gui.PhotoModeScreen;
 import net.minecraft.core.enums.ChatVisibility;
+import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.util.helper.Direction;
 import org.lwjgl.opengl.GL11;
 
@@ -102,7 +103,7 @@ public class IngameHud extends Gui
         }
 
         // Render pumpkin overlay
-        ItemStack headSlotItem = mc.thePlayer.inventory.armorItemInSlot(3);
+        ItemStack headSlotItem = mc.thePlayer.inventory.armorItemInSlot(IArmorItem.PIECE_HEAD);
         if (mc.gameSettings.thirdPersonView.value == 0 && headSlotItem != null && headSlotItem.itemID == Blocks.PUMPKIN_CARVED_IDLE.id)
         {
             renderPumpkinBlur(width, height);
@@ -512,7 +513,7 @@ public class IngameHud extends Gui
         {
             for (int i = 0; i < 4; i++)
             {
-                ItemStack stack = mc.thePlayer.inventory.armorInventory[3 - i];
+                ItemStack stack = mc.thePlayer.inventory.armorInventory[IArmorItem.PIECE_HEAD - i];
 
                 if (stack != null)
                 {
diff --git a/src/main/java/net/minecraft/client/input/MouseFilter.java b/src/main/java/net/minecraft/client/input/MouseFilter.java
index 09e9445af..683511d65 100644
--- a/src/main/java/net/minecraft/client/input/MouseFilter.java
+++ b/src/main/java/net/minecraft/client/input/MouseFilter.java
@@ -4,11 +4,14 @@ package net.minecraft.client.input;
 public class MouseFilter
 {
 
+    private float field_22388_a;
+    private float field_22387_b;
+    private float field_22389_c;
+
     public MouseFilter()
     {
     }
-
-    public float func_22386_a(float delta, float sensitivity)
+    public float getSmoothedDelta(float delta, float sensitivity)
     {
         field_22388_a += delta;
         delta = (field_22388_a - field_22387_b) * sensitivity;
@@ -20,13 +23,10 @@ public class MouseFilter
         field_22387_b += delta;
         return delta;
     }
+
     public void reset(){
         field_22388_a = 0;
         field_22387_b = 0;
         field_22389_c = 0;
     }
-
-    private float field_22388_a;
-    private float field_22387_b;
-    private float field_22389_c;
 }
